/**
 * 
 */
package de.fhg.fokus.ngni.odysseus.service.messaging;

import java.util.Dictionary;
import java.util.Hashtable;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.service.event.EventConstants;
import org.osgi.service.event.EventHandler;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author alb
 *
 */
public class Activator implements BundleActivator {
	
	private final Logger log = LoggerFactory.getLogger(Activator.class);

	final static String[] topics = {"Messaging"};
	
//	private EventAdmin eventAdmin;
	
	/* (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		log.debug("Messaging Activator started");
		
		//get the EventAdmin
//		ServiceReference reference = context.getServiceReference(EventAdmin.class.getName());
//		if(reference != null){
//			EventAdmin eventAdmin = (EventAdmin) context.getService(reference);
//		}
		
		// EventHandler is registered and Event will be called to fire the Class/method needed
		Dictionary<String, Object> dictionary = new Hashtable<String, Object>();
		dictionary.put(EventConstants.EVENT_TOPIC, topics);
		context.registerService(EventHandler.class.getName(), new MessageEventHandler(context), dictionary);
		
		log.debug("MESSAGE Test");
		Messaging messaging = new Messaging();
		String[] recipients = {"sip:alb@fokus.fraunhofer.de"};
		String sender = "sip:alb-test@fokus.fraunhofer.de";
		String content = "ODYSSEUS";
		log.debug("RESULT: " + messaging.sendMessage(recipients, sender, content));
	}

	/* (non-Javadoc)
	 * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		// TODO Auto-generated method stub

	}
	
	/*public class ActivatorEventHandler implements EventHandler{
		
		public void handleEvent(Event event) {
			log.debug("Reached Messaging ActivatorEventHandler");
			log.debug("Topic: " + event.getTopic());
			log.debug("Params: " + String.valueOf((Map) event.getProperty("parameters")));
			
			Object returnValue = null;
			
			String eventProperty = (String) event.getProperty("event"); 
			
			//call sendMessage method
			if(eventProperty.equals("sendMessage")){
				Messaging messaging;
				try {
					messaging = new Messaging();
					
					Map map = (Map) event.getProperty("parameters");
					String sender = (String) map.get("sender");
					String[] recipients = (String[]) map.get("recipients");
					String message = (String) map.get("message");
					returnValue = messaging.sendMessage(recipients, sender, message);
					
				} catch (MalformedURLException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					//TODO error handling
				}

			}
			else{
				log.debug("No event match found");
			}
			
        	Dictionary <String, Object> dictionary = new Hashtable<String, Object>();
        	dictionary.put("SCXMLServiceFlow", event.getProperty("SCXMLServiceFlow"));
			
			if(returnValue != null){
	        	dictionary.put("topic", eventProperty + "_true");
	        	dictionary.put("returnValue", returnValue);
			}
			else{
				dictionary.put("topic", eventProperty + "_false");
			}

			eventAdmin.sendEvent(new Event("de/fhg/fokus/ngni/odysseus/scxml/handler/SCXMLEventHandler", dictionary));
			//TODO: create a variable: "de/fhg/fokus/ngni/odysseus/scxml/handler/SCXMLEventHandler"
			
		}
	}*/


}
