/**
 * 
 */
package de.fhg.fokus.ngni.odysseus.service.messaging;

import java.net.MalformedURLException;
import java.util.Dictionary;
import java.util.Hashtable;
import java.util.Map;

import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.event.Event;
import org.osgi.service.event.EventAdmin;
import org.osgi.service.event.EventHandler;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author alb
 *
 */
public class MessageEventHandler implements EventHandler{
	
	private final Logger log = LoggerFactory.getLogger(MessageEventHandler.class);
	
	private EventAdmin eventAdmin;
	
	public MessageEventHandler(BundleContext context){
		ServiceReference reference = context.getServiceReference(EventAdmin.class.getName());
		if(reference != null){
			eventAdmin = (EventAdmin) context.getService(reference);
		}
		
	}
	
	public void handleEvent(Event event) {
		log.debug("Reached MessagingEventHandler");
		log.debug("Topic: " + event.getTopic());
		log.debug("Params: " + String.valueOf((Map) event.getProperty("parameters")));
		
		Object returnValue = null;
		
		String eventProperty = (String) event.getProperty("event"); 
		
		//call sendMessage method
		if(eventProperty.equals("sendMessage")){
			Messaging messaging;
			try {
				messaging = new Messaging();
				
				Map map = (Map) event.getProperty("parameters");
				String sender = (String) map.get("sender");
				String[] recipients = (String[]) map.get("recipients");
				String message = (String) map.get("message");
				returnValue = messaging.sendMessage(recipients, sender, message);
				
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				//TODO error handling
			}

		}
		else{
			log.debug("No event match found");
		}
		
    	Dictionary <String, Object> dictionary = new Hashtable<String, Object>();
    	dictionary.put("SCXMLServiceFlow", event.getProperty("SCXMLServiceFlow"));
		
		if(returnValue != null){
        	dictionary.put("topic", eventProperty + "_true");
        	dictionary.put("returnValue", returnValue);
		}
		else{
			dictionary.put("topic", eventProperty + "_false");
		}
		
		

		eventAdmin.sendEvent(new Event("de/fhg/fokus/ngni/odysseus/scxml/handler/SCXMLEventHandler", dictionary));
		//TODO: create a variable: "de/fhg/fokus/ngni/odysseus/scxml/handler/SCXMLEventHandler"
		
	}
}